#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# -----------------------------------------------------------------------
# scrollphat.py

import time
import scrollphat
import socket
# import os
# ------------------------------------------------------------------------------------
def init():
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    s.connect(("franzis.de",80))
    global ip
    ip = s.getsockname()[0]
    global hname
#    hname = os.uname()[1]
    hname = socket.gethostname()
    s.close()
# ------------------------------------------------------------------------------------
def turnoffLED():
   scrollphat.clear()
# ------------------------------------------------------------------------------------
def main():
    print(ip)
#    print(socket.gethostname())
    scrollphat.set_brightness(20)
    cpu_values = [0] * 11
    while True:
        try:
            scrollphat.clear()
            scrollphat.write_string("HOST: "+ hname + " - IP: " + ip + "    ", 11)
            for i in range(0, scrollphat.buffer_len() - 11):
                scrollphat.scroll()
                time.sleep(0.1)
        except KeyboardInterrupt:
            turnoffLED()
            sys.exit(-1)
# ------------------------------------------------------------------------------------
if __name__ == '__main__':
   init()
   main()
   exit()
# ---------------------------------- EOF ---------------------------------------------
