#!/bin/python
# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2017
# -----------------------------------------------------------------------
# bottle_pisauger.py
# Pfad /Staubsauger/bottle
#
from bottle import route, run, template, static_file #, get
import signal
import os
import subprocess
s='Sun 00:00 - None -\r\nMon 13:00 H\r\nTue 00:00 - None -\r\nWed 13:00 H\r\nThu 00:00 - None -\r\nFri 13:00 H\r\nSat 00:00 - None -\r\n\x1a'
#mjpg_cmd='./mjpg_streamer -o "output_http.so -p 8080 -w ./www" -i "input_raspicam.so -ex night -x 640 -y 480"'

def webgui():
	intro='<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html>'
	intro0='<head><title>LiveView-Vorwerk/Neato.Staubsauger</title></head><body><b>LiveView-Vorwerk/Neato.Staubsauger</b></br></br>'
#	video0='<video controls="controls" width="1280" height="720" autoplay="autoplay" >'
#	video0='<video controls="controls" width="640" height="360" autoplay="autoplay" >'
	video0='<iframe src="http://192.168.123.39:8081/?action=stream" height="320" width="640" frameborder="0"></iframe>'
#<img id="streamimage" class="xform" src="/?action=stream" />
#	video1='<source src="sauger_stream.m3u8" type="application/x-mpegURL" /></video>'
	video1=''
	video2='</br></br>'
	strHTML0=intro0+video0+video1+video2
        # intro1='<b>Kommando /neato/BEFEHL erforderlich!</b></br></br>'
	intro1='<b>Steuerung des Vorwerk/Neato.Staubsaugers</b></br></br>'
        table1_in='<table border=0 cellspacing=0 cellpadding=0><tr>'
	table1_z1s1='<td width=205 valign=top align="center"><p><a href="/neato/1_V_Kurve_Links"><img src="/static/1.png" width="210" height="34" border="0" alt="1"></a></p></td>'
        table1_z1s2='<td width=205 valign=top align="center"><p><a href="/neato/2_V_Geradeaus"><img src="/static/2.png" width="210" height="34" border="0" alt="2"></a></p></td>'
        table1_z1s3='<td width=205 valign=top align="center"><p><a href="/neato/3_V_Kurve_Rechts"><img src="/static/3.png" width="210" height="34" border="0" alt="3"></a></p></td>'
        table1_z1out='</tr><tr>'
        table1_z2s1='<td width=205 valign=top align="center"><p><a href="/neato/4_Rotation_Links"><img src="/static/4.png" width="210" height="34" border="0" alt="4"></a></p></td>'
        table1_z2s2='<td width=205 valign=top align="center"><p><a href="/neato/5_Stop"><img src="/static/5.png" width="210" height="34" border="0" alt="5"></a></p></td>'
        table1_z2s3='<td width=205 valign=top align="center"><p><a href="/neato/6_Rotation_Rechts"><img src="/static/6.png" width="210" height="34" border="0" alt="6"></a></p></td>'
        table1_z2out='</tr><tr>'
        table1_z3s1='<td width=205 valign=top align="center"><p><a href="/neato/7_R_Kurve_Links"><img src="/static/7.png" width="210" height="34" border="0" alt="7"></a></p></td>'
        table1_z3s2='<td width=205 valign=top align="center"><p><a href="/neato/8_R_Geradeaus"><img src="/static/8.png" width="210" height="34" border="0" alt="8"></a></p></td>'
        table1_z3s3='<td width=205 valign=top align="center"><p><a href="/neato/9_R_Kurve_Rechts"><img src="/static/9.png" width="210" height="34" border="0" alt="9"></a></p></td>'
        table1_z3out='</tr>'
        table1_out='</table>'
	strHTML1=intro1+table1_in+table1_z1s1+table1_z1s2+table1_z1s3+table1_z1out+table1_z2s1+table1_z2s2+table1_z2s3+table1_z2out+table1_z3s1+table1_z3s2+table1_z3s3+table1_z3out+table1_out
        intro2='</br></br><b>Sonstiges</b></br></br>'
        table2_in='<table border=1 cellspacing=0 cellpadding=0> <tr>'
        table2_z1s1='<td width=205 valign=top align="center"><p><a href="/neato/10_SHUTTER">SHUTTER</a></p></td>'
        table2_z1s2='<td width=205 valign=top align="center"><p><a href="/neato/11_VID_30S">VID_30S</a></p></td>'
        table2_z1s3='<td width=205 valign=top align="center"><p><a href="/neato/12_V_RESET">V_RESET</a></p></td>'
        table2_z1out='</tr></table></body></html>'
        strHTML2=intro2+table2_in+table2_z1s1+table2_z1s2+table2_z1s3+table2_z1out
        strHTML=strHTML0+strHTML1+strHTML2
        return strHTML

def webgui_ohne_video():
#def webgui(): und obige Function auskommentieren!
	intro1='<b>Kommando /neato/BEFEHL erforderlich!</b></br></br>'
	table1_in='<table border=0 cellspacing=0 cellpadding=0><tr>'
	table1_z1s1='<td width=205 valign=top align="center"><p><a href="/neato/1_V_Kurve_Links"><img src="/static/1.png" width="210" height="34" border="0" alt="1"></a></p></td>'
	table1_z1s2='<td width=205 valign=top align="center"><p><a href="/neato/2_V_Geradeaus"><img src="/static/2.png" width="210" height="34" border="0" alt="2"></a></p></td>'
	table1_z1s3='<td width=205 valign=top align="center"><p><a href="/neato/3_V_Kurve_Rechts"><img src="/static/3.png" width="210" height="34" border="0" alt="3"></a></p></td>'
	table1_z1out='</tr><tr>'
	table1_z2s1='<td width=205 valign=top align="center"><p><a href="/neato/4_Rotation_Links"><img src="/static/4.png" width="210" height="34" border="0" alt="4"></a></p></td>'
	table1_z2s2='<td width=205 valign=top align="center"><p><a href="/neato/5_Stop"><img src="/static/5.png" width="210" height="34" border="0" alt="5"></a></p></td>'
	table1_z2s3='<td width=205 valign=top align="center"><p><a href="/neato/6_Rotation_Rechts"><img src="/static/6.png" width="210" height="34" border="0" alt="6"></a></p></td>'
	table1_z2out='</tr><tr>'
	table1_z3s1='<td width=205 valign=top align="center"><p><a href="/neato/7_R_Kurve_Links"><img src="/static/7.png" width="210" height="34" border="0" alt="7"></a></p></td>'
	table1_z3s2='<td width=205 valign=top align="center"><p><a href="/neato/8_R_Geradeaus"><img src="/static/8.png" width="210" height="34" border="0" alt="8"></a></p></td>'
	table1_z3s3='<td width=205 valign=top align="center"><p><a href="/neato/9_R_Kurve_Rechts"><img src="/static/9.png" width="210" height="34" border="0" alt="9"></a></p></td>'
	table1_z3out='</tr>'
	table1_out='</table>'
	strHTML1=intro1+table1_in+table1_z1s1+table1_z1s2+table1_z1s3+table1_z1out+table1_z2s1+table1_z2s2+table1_z2s3+table1_z2out+table1_z3s1+table1_z3s2+table1_z3s3+table1_z3out+table1_out
        intro2='</br></br><b>Steuerung</b></br>'
        table2_in='<table border=1 cellspacing=0 cellpadding=0> <tr>'
        table2_z1s1='<td width=205 valign=top align="center"><p><a href="/neato/10_SHUTTER">SHUTTER</a></p></td>'
        table2_z1s2='<td width=205 valign=top align="center"><p><a href="/neato/11_VID_30S">VID_30S</a></p></td>'
        table2_z1s3='<td width=205 valign=top align="center"><p><a href="/neato/12_V_RESET">V_RESET</a></p></td>'
        table2_z1out='</tr></table>'
	strHTML2=intro2+table2_in+table2_z1s1+table2_z1s2+table2_z1s3+table2_z1out
	strHTML=strHTML1+strHTML2
	return strHTML
	
def webgui_ohneIMG(): # ohne Grafik
	intro1='<b>Kommando /neato/BEFEHL erforderlich!</b></br></br>'
	table1_in='<table border=1 cellspacing=0 cellpadding=0> <tr>'
	table1_z1s1='<td width=205 valign=top align="center"><p><a href="/neato/1_V_Kurve_Links">1</a></p></td>'
	table1_z1s2='<td width=205 valign=top align="center"><p><a href="/neato/2_V_Geradeaus">2</a></p></td>'
	table1_z1s3='<td width=205 valign=top align="center"><p><a href="/neato/3_V_Kurve_Rechts">3</a></p></td>'
	table1_z1out='</tr> <tr>'
	table1_z2s1='<td width=205 valign=top align="center"><p><a href="/neato/4_Rotation_Links">4</a></p></td>'
	table1_z2s2='<td width=205 valign=top align="center"><p><a href="/neato/5_Stop">5</a></p></td>'
	table1_z2s3='<td width=205 valign=top align="center"><p><a href="/neato/6_Rotation_Rechts">6</a></p></td>'
	table1_z2out='</tr> <tr>'
	table1_z3s1='<td width=205 valign=top align="center"><p><a href="/neato/7_R_Kurve_Links">7</a></p></td>'
	table1_z3s2='<td width=205 valign=top align="center"><p><a href="/neato/8_R_Geradeaus">8</a></p></td>'
	table1_z3s3='<td width=205 valign=top align="center"><p><a href="/neato/9_R_Kurve_Rechts">9</a></p></td>'
	table1_z3out='</tr>'
	table1_out='</table>'
	strHTML1=intro1+table1_in+table1_z1s1+table1_z1s2+table1_z1s3+table1_z1out+table1_z2s1+table1_z2s2+table1_z2s3+table1_z2out+table1_z3s1+table1_z3s2+table1_z3s3+table1_z3out+table1_out
        intro2='</br></br><b>Steuerung</b></br>'
        table2_in='<table border=1 cellspacing=0 cellpadding=0> <tr>'
        table2_z1s1='<td width=205 valign=top align="center"><p><a href="/neato/10_SHUTTER">SHUTTER</a></p></td>'
        table2_z1s2='<td width=205 valign=top align="center"><p><a href="/neato/11_VID_30S">VID_30S</a></p></td>'
        table2_z1s3='<td width=205 valign=top align="center"><p><a href="/neato/12_V_RESET">V_RESET</a></p></td>'
        table2_z1out='</tr></table>'
	strHTML2=intro2+table2_in+table2_z1s1+table2_z1s2+table2_z1s3+table2_z1out
	strHTML=strHTML1+strHTML2
	return strHTML
# --------------------------------------------------------------------------------------------------------------------------------
@route('/static/:filename')    #.*#', name='png')
def static(filename):
	rootpath='/home/pi/bottle/static/'
	return static_file(filename, rootpath)
# --------------------------------------------------------------------------------------------------------------------------------
@route('/neato')
@route('/neato/')
# --------------------------------------------------------------------------------------------------------------------------------
def neato():
	tmp = webgui()
	return tmp
@route('/neato/:name')
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='1_V_Kurve_Links'):
	testMode('On')
	setMotor(20,40,20)	
	testMode('Off')
	tmp = webgui()
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt!</b>', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='2_V_Geradeaus'):
	testMode('On')
	setMotor(40,40,20)	
	testMode('Off')
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='3_V_Kurve_Rechts'):
	testMode('On')
	setMotor(40,20,20)		
	testMode('Off')
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='4_Rotation_Links'):
	testMode('On')
	setMotor(20,-20,20)		
	testMode('Off')
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='5_Stop'):
	testMode('On')
	setMotor()
	testMode('Off')
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='6_Rotation_Rechts'):
	testMode('On')
	setMotor(-20,20,20)	
	testMode('Off')
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------	
def index(name='7_R_Kurve_Links'):
	testMode('On')
	setMotor(-20,-40,20)	
	testMode('Off')
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------	
def index(name='8_R_Geradeaus'):
	testMode('On')
	setMotor(-20,-20,20)
	testMode('Off')
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------	
def index(name='9_R_Kurve_Rechts'):
	testMode('On')
	setMotor(-40,-20,20)	
	testMode('Off')
	return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='10_SHUTTER'):
#    foto()
# hier koennte eine foto funktion hinterlegt werden
    return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='11_VID_30S'):
#        hier koennte eine videoaufnahmefunktion hinterkegt werden
        return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
def index(name='12_V_RESET'):
#        hier koennte eine Resetfunktion hinterlegt werden
        return template(tmp+'<b>Kommando {{name}} wurde ausgefuehrt</b>!', name=name)
# --------------------------------------------------------------------------------------------------------------------------------
#  1_V_Kurve_Links
# 2_V_Geradeaus
# 3_V_Kurve_Rechts
# 4_Rotation_Links
# 5_Stop
# 6_Rotation_Rechts
# 7_R_Kurve_Links
# 8_R_Geradeaus
# 9_R_Kurve_Rechts
def setMotor(linksMM=0, rechtsMM=0, speed=0):
# fahren nur möglich, wenn testmode auf on
# Command: SetMotor
# Description: Sets the specified motor to run in a direction at a requested speed. (TestMode Only)
# Usage: SetMotor [LWheelDist <LWheelDist_value>] [RWheelDist <RWheelDist_value>] [Speed <Speed_value>] [Accel <Accel_value>] [RPM <RPM_value>] [Brush] [VacuumOn] [VacuumOff] [VacuumSpeed <VacuumSpeed_value>] [RWheelDisable] [LWheelDisable] [BrushDisable] [RWheelEnable] [LWheelEnable] [BrushEnable]
# Options:
# Flag 	Description
# linksMM = LWheelDist 	Distance in millimeters to drive Left wheel. (Pos = forward, neg = backward)
# rechtsMM = RWheelDist 	Distance in millimeters to drive Right wheel. (Pos = forward, neg = backward)
# Speed 	Speed in millimeters/second. (Required only for wheel movements)
# Accel 	Acceleration in millimeters/second.
# (Used only for wheel movements. Defaults to ‘Speed’.)
#
# RPM 	Next argument is the RPM of the motor.
# Not used for wheels, but applied to all other motors specified in the command line.
#
# Brush 	Brush motor forward (Mutually exclusive with wheels and vacuum.)
# VacuumOn 	Vacuum motor on (Mutually exclusive with VacuumOff)
# VacuumOff 	Vacuum motor off (Mutually exclusive with VacuumOn)
# VacuumSpeed 	Vacuum speed in percent (1-100).
# RWheelDisable 	Disable Right Wheel motor
# LWheelDisable 	Disable Left Wheel motor
# BrushDisable 	Disable Brush motor
# RWheelEnable 	Enable Right Wheel motor
# LWheelEnable 	Enable Left Wheel motor
# BrushEnable 	Enable Brush motor
# Return Format: None
	setMotorCmd='setMotor '+'LWheelDist '+str(linksMM)+' RWheelDist '+str(rechtsMM)+' Speed '+str(speed)
	print '-' * 50
	print 'setMotorCmd= ', setMotorCmd
	print '-' * 50
# --------------------------------------------------------------------------------------------------------------------------------
def testMode(sw='off'):
#Command: TestMode
# Description: Sets TestMode on or off. Some commands can only be run in TestMode.
# Usage: TestMode [On] [Off]
	if sw == 'on' or sw =='ON' or sw =='On':
		testModeCmd='TestMode On'
	else:
		testModeCmd='TestMode Off'
	print '-' * 50
	print 'testModeCmd= ', testModeCmd
	print '-' * 50
# --------------------------------------------------------------------------------------------------------------------------------
def cleanHouse():
	print '-' * 50
	cleanHouseCmd='clean'
	print 'cleanHouseCmd= ', cleanHouseCmd
	print '-' * 50
	return
# --------------------------------------------------------------------------------------------------------------------------------
def cleanHouseStop():
	print '-' * 50
	cleanHouseStopCmd='clean stop'
	print 'cleanHouseStopCmd= ',cleanHouseStopCmd
	print '-' * 50
	return
# --------------------------------------------------------------------------------------------------------------------------------
def getSched(s):
	i = 0
	print '-' * 50
	while int(i) < 7:
		dy = s.split("\r\n")[i]
		if dy.split(" ")[0].strip() <> '':
			if dy.split(" ")[2].strip() <> '-':
#			if s.split("\r\n")[i].split(" ")[2].strip() <> '-':
				print "| Tag =", dy.split(" ")[0].strip(), "Zeit = ", dy.split(" ")[1].strip(), "Flag = ", dy.split(" ")[2].strip()
			else:
				print "| Tag =", dy.split(" ")[0].strip(), "Zeit = ", dy.split(" ")[1].strip(), "Flag = Nicht festgelegt"#, dy.split(" ")[$
		i=i+1
		print '-' * 50
	return
# --------------------------------------------------------------------------------------------------------------------------------
def setSched(d=0, hour=0, min=0, house=1, status=1):
	# d = int -> Sun=0,Sat=6 # required
	# hour = int 0-23 # required
	# min = int 0-59 # required
	# status = int 0,1 , 0 Schedule aus, 1 Schedule an # default 1
	# wenn 1 Enable Scheduled cleanings
	# wenn 0 Disable Scheduled cleanings
# Day 	Day of the week to schedule cleaning for. Sun=0,Sat=6. (required)
# Hour 	Hour value 0..23 (required)
# Min 	Minutes value 0..59 (required)
# House 	Schedule to Clean whole house (default)
# (Mutually exclusive with None)
# None 	Remove Scheduled Cleaning for specified day. Time is ignored.
# (Mutually exclusive with House)
# ON 	Enable Scheduled cleanings (Mutually exclusive with OFF)
# OFF 	Disable Scheduled cleanings (Mutually exclusive with ON)
	d=int(d)
	hour=int(hour)
	min=int(min)
	house=int(house)
	status=int(status)
#
	if ( d < 0 or d > 6):
		d = 0
	if ( hour < 0 or hour > 23):
		hour= 0
	if ( hour >= 0 or hour <=9):
		strHour='0'+str(hour)
	else:
		strHour=str(hour)
	if ( min < 0 or min > 59):    
                min = 0
	if ( min >= 0 or min <=9):
        	strMin='0'+str(min)
	else:
        	strMin=str(min)
	if ( house <= 0 or house > 2):
		house = 0
		strHouse='NONE'
	else:
		if house == 2:
			# spotreinigung = 2 
		        strHouse='SPOT'
		else:
			strHouse='HOUSE'
	if ( status <= 0 or status > 1):
		status = 0
		strStatus='OFF'
	else:
		strStatus='ON'
	print "Tag", d, " Hour = ", hour, " Min = ", min, "Variable House= ", strHouse, "Status =", status
	setScheduleCmd='setSchedule '+str(d)+' '+strHour+':'+strMin+' '+strHouse+' '+strStatus
	print 'setScheduleCmd=', setScheduleCmd
	return
# --------------------------------------------------------------------------------------------------------------------------------
def test():
	# Auseinanderparsen..
	dy_1 = s.split("\r\n")[0]
	dy_2 = s.split("\r\n")[1]
	dy_3 = s.split("\r\n")[2]
	dy_4 = s.split("\r\n")[3]
	dy_5 = s.split("\r\n")[4]
	dy_6 = s.split("\r\n")[5]
	dy_7 = s.split("\r\n")[6]

# entsprechende w1_slave-Datei des jeweiligen Device oeffnen
	print "Sonntag", dy_1, "Tag =", dy_1.split("-")[0] , "Zeit = ", dy_1.split("-")[1]
	print "Montag", dy_2, "Tag =", dy_2.split("-")[0], "Zeit = ", dy_2.split("-")[1]
	print "Dienstag", dy_3, "Tag =", dy_3.split("-")[0] , "Zeit = ", dy_3.split("-")[1] # s.split("\n\r")[2]
	print "Mittwoch", dy_4, "Tag =", dy_4.split("-")[0] , "Zeit = ", dy_4.split("-")[1] # s.split("\n\r")[3]
	print "Donnerstag", dy_5, "Tag =", dy_5.split("-")[0] , "Zeit = ", dy_5.split("-")[1] # s.split("\n\r")[4]
	print "Freitag", dy_6, "Tag =", dy_6.split("-")[0] , "Zeit = ", dy_6.split("-")[1] # s.split("\n\r")[5]
	print "Samstag", dy_7, "Tag =", dy_7.split("-")[0] , "Zeit = ", dy_7.split("-")[1] # s.split("\n\r")[6]

#-----------------------------------------------------------
# diverses zum Test und Ausprobieren...
getSched(s)
# dy, hour, min, house, status
setSched(6,3,2,2,1)
cleanHouse()
cleanHouseStop()
#sw='off'
testMode('On')
setSched()
setMotor()
# --------------------------------------------------------------------------------------------------------------------------------
subprocess.call("/home/pi/bottle/mjpeg.sh")
#run(host='localhost', port=8080)
#  falls im heimnetz dann
run(host='192.168.123.39', port=8080)
# --------------------------------------------------  EOF ------------------------------------------------------------------------