//Include ArduPi library
#include "arduPi.h"
/*********************************************************
 *  IF YOUR ARDUINO CODE HAS OTHER FUNCTIONS APART FROM  *
 *  setup() AND loop() YOU MUST DECLARE THEM HERE        *
 * *******************************************************/
int dirPin = 8;
int stepperPin = 7;
void setup() {
 pinMode(dirPin, OUTPUT);
 pinMode(stepperPin, OUTPUT);
}

void step(boolean dir,int steps){
 digitalWrite(dirPin,dir);
 delay(60);
 for(int i=0;i<steps;i++){
   digitalWrite(stepperPin, HIGH);
   delayMicroseconds(1000);
   digitalWrite(stepperPin, LOW);
   delayMicroseconds(1000);
 }
}

int r = 100;
void loop(){
  // true = links
 step(true,r);
 delay(600);
 // false = rechts
 step(false,r*2);
 delay(600);
}

/**************************
 * YOUR ARDUINO CODE HERE *
 * ************************/

int main (){
        setup();
        while(1){
                loop();
        }
        return (0);
}
