#!/bin/bash
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2107
# -----------------------------------------------------------------------
# calc.sh
# 
iSW_SHOW_IMGR=0
iSW_SHOW_IMGL=0
iSW_SHOW_DEL=0
iSW_SHUTTER=0
iSW_VIDEO=0

function zaehler_init(){
        if [ -e  "/usr/bin/bc" ]; then
                echo -e "\n\n[franzisCAM] OK, bc bereits installiert"
        else
                echo -e "\n\n[franzisCAM] kein bc installiert, wird nachgeholt.."
                sudo apt-get install bc -y
        fi
}
#-------------------------------------------------------------------------
function inc_switch(){
        local name_switch=${1}
        local switch_wert=${2}
        echo "Uebergeben wurde :" $name_switch " und " $switch_wert
        local switch_wertneu=0
        if [ ! -z "$switch_wert" ];then
                local switch_wertneu=`echo $switch_wert+1 | bc`
        fi
        case "$name_switch" in
                "SW_SHOW_IMGR") # SW_SHOW_IMGR
#               iSW_SHOW_IMGR=$switch_wertneu;
#               echo "IMGR+1"
                iSW_SHOW_IMGR=$switch_wertneu
                ;;

                "SW_SHOW_IMGL") # SW_SHOW_IMGL
                iSW_SHOW_IMGL=$switch_wertneu
                ;;

                "SW_SHOW_IMGL") # SW_SHOW_IMGL
                iSW_SHOW_IMGL=$switch_wertneu
                ;;

                "SW_SHOW_DEL") # SW_SHOW_DEL
                iSW_SHOW_DEL=$switch_wertneu
                ;;

                "SW_SHUTTER") # SW_SHUTTER
                iSW_SHUTTER=$switch_wertneu
                ;;

                "SW_VIDEO") # SW_VIDEO
                iSW_VIDEO=$switch_wertneu
                ;;
        esac
}
#-------------------------------------------------------------------------
function desc_switch(){
        local name_switch=${1}
        local switch_wert=${2}
        echo "Uebergeben wurde :" $name_switch " und " $switch_wert
        local switch_wertneu=0
        if [ ! -z "$switch_wert" ];then
                local switch_wertneu=`echo $switch_wert-1 | bc`
        fi
        if [ "$switch_wertneu" -lt 0 ];then
                switch_wertneu=0
        fi
        case "$name_switch" in
                "SW_SHOW_IMGR") # SW_SHOW_IMGR
#               iSW_SHOW_IMGR=$switch_wertneu;
#               echo "IMGR-1"
                iSW_SHOW_IMGR=$switch_wertneu
                ;;

                "SW_SHOW_IMGL") # SW_SHOW_IMGL
                iSW_SHOW_IMGL=$switch_wertneu 
                ;;

                "SW_SHOW_DEL") # SW_SHOW_DEL
                iSW_SHOW_DEL=$switch_wertneu
                ;;

                "SW_SHUTTER") # SW_SHUTTER
                iSW_SHUTTER=$switch_wertneu
                ;;

                "SW_VIDEO") # SW_VIDEO
                iSW_VIDEO=$switch_wertneu
                ;;
        esac
}
#-------------------------------------------------------------------------

schalter="SW_SHOW_IMGR"
wert=$iSW_SHOW_IMGR
inc_switch $schalter $wert
echo "Aufruf : inc_switch" $schalter $wert
echo "Wert neu fuer schalter = " $iSW_SHOW_IMGR
if [ "$iSW_SHOW_IMGR" -eq 1 ]; then
        echo "Wert ist eins"
else
        echo "Wert ist nicht eins"
fi
desc_switch $schalter $iSW_SHOW_IMGR
echo "Aufruf : desc_switch" $schalter $wert
echo "Wert neu nach Desc fuer Schalter = " $iSW_SHOW_IMGR
if [ "$iSW_SHOW_IMGR" -eq 0 ]; then
        echo "Wert ist null"
else
        echo "Wert ist nicht null"
fi
exit 0
