#!/bin/bash
# -----------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2107
# -----------------------------------------------------------------------
function toggle_gpio(){
gport=$1;
if ! [ -d /sys/class/gpio/gpio$gport ]
then
  echo "$gport" > /sys/class/gpio/export
  echo "out" > /sys/class/gpio/gpio$gport/direction
fi
gstatus=$2;
if [ $gstatus -gt 1 ]
then
  gstatus=1
fi
echo "$gstatus" > /sys/class/gpio/gpio$gport/value
}
exit 0
#---------------------- EOF --------------------------------