#!/usr/bin/env python
# -*- coding: utf-8 -*-
# ---------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ---------------------------------------------------------------------
# piopencv_step01.py
#
import cv2
# Bild aus aktuellen Verzeichnis laden
image = cv2.imread("foto.jpg", 1)
# Beschreibungsdatei laden
faceCascade = cv2.CascadeClassifier('haarcascade_frontalface_alt.xml')
# Grauwerttrasformation
gray = cv2.cvtColor(image,cv2.COLOR_BGR2GRAY)
# Nach Gesicht mit der Beschreibungsdatei in der Image Datei suchen
faces = faceCascade.detectMultiScale(gray,
        scaleFactor=1.1,
        minNeighbors=5,
        minSize=(30, 30),
        flags=cv2.CASCADE_SCALE_IMAGE
)
print "Es wurde(n) "+str(len(faces))+" Gesicht(er) gefunden.\nDas Ergebnis wurde in Datei <gesicht.jpg> gesichert.\n"
# Rechteck um jedes gefundene Gesicht zeichnen
for (x,y,w,h) in faces:
    cv2.rectangle(image,(x,y),(x+w,y+h),(0,0, 255),3)
# Bild speichern
cv2.imwrite('gesicht.jpg',image)
