#!/bin/bash
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016/2017
# ----------------------------------------------------
# Skript: piriblinkcam.sh
#
red=0 # ist GPIO 17 - Pin 11
green=1 # ist GPIO 18 - Pin 12
piri=11 # ist GPIO 07
FILENAME=$(date +"%m-%d-%y|||%H%M%S")
MAILFILE="/var/tmp/mailpic.jpg"
# ----------------------------------------------------------------------
#  funktion init
#  GPIO einstellen und LEDs initialisieren fuer Reed-Schalter
# ----------------------------------------------------------------------
init ()
{
  echo initialisieren...
  gpio mode $piri in
  gpio mode $piri up
  gpio mode $foto out
  gpio mode $red in
  gpio mode $red up
  gpio mode $green out
  gpio write green 1
}
# ----------------------------------------------------------------------
# Schaltkreis einschalten
# ----------------------------------------------------------------------
init
# schleife bis ctrl-c
while true; do
if [ $(gpio read $piri) -eq  0 ]; then
  if [ `gpio read $red` = 1 ]; then
     gpio write $green 1
   else
     gpio write $green 0;
  fi
else
   gpio write $green 0;
   echo "Bewegung"
   echo "-> erstelle Aufnahme"
    if [ "$(ls /dev/video0)" ]; then
        echo "Videodevice an Raspberry Pi angeschlossen"
        /usr/bin/fswebcam -r 320x240 -i 0 -d /dev/video0 --jpeg 95 --shadow --title "Raspi im Vogelhaus" --subtitle "Yummi-Front" --info "Monitor: Active" -v $MAILFILE
        cp ${MAILFILE} /var/tmp/${FILENAME}.jpg
    else
        echo "KEIN Videodevice an Raspberry Pi angeschlossen"
     fi
fi
sleep 0.1
done
exit 0
# -----------------------------------------------------------------------
