#!/usr/bin/env python
#-*- coding:utf-8 -*-
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
#
# Datei gpsthief-step2.py
#
# Funktion Standortinformation
# installiertes geopy
#
import sys, os
import subprocess
import time
from geopy import geocoders
from geopy.geocoders import GoogleV3
# ----------------------------------------------------
def cmd_exists(cmd):
    return subprocess.call("type " + cmd, shell=True,
        stdout=subprocess.PIPE, stderr=subprocess.PIPE) == 0
# ----------------------------------------------------

# ----------------------------------------------------
def main():
  os.system('clear')
  delay=10
  GPSPIPE="/usr/bin/gpspipe"
  print "[GPS] Check ob ", GPSPIPE ," vorhanden..."
  if cmd_exists(GPSPIPE):
    # "vorhanden "
    print "[GPS] Koordinaten..."
    g = geocoders.GoogleV3()
    try:
       while True:
          LONGITUDE="gpspipe -w -n 5 | grep lon | grep -i -m 1 tpv | cut -d ',' -f8 | cut -d ':' -f2"
          LATITUDE="gpspipe -w -n 5 | grep lat | grep -i -m 1 tpv | cut -d ',' -f7 | cut -d ':' -f2"
          os.system('clear')
          print "[GPS] Koordinaten..."
          longitude=os.popen(LONGITUDE).read()
          longitude=longitude.strip()
          latitude=os.popen(LATITUDE).read()
          latitude=latitude.strip()
          print "| Breitengrad: ", latitude
          print "| Laengengrad: ", longitude
          google ="| Google Maps: https://maps.google.com/maps?q="
          google=google+latitude+","+longitude
          print google
          placenow = g.reverse(latitude+","+longitude,exactly_one=True) # nur 1ter Treffer in Location-Liste
          print "| Ort: ", placenow
          time.sleep(delay)
    except KeyboardInterrupt:
       sys.exit(0)
  else:
     print "[GPS] ",GPSPIPE , "nicht vorhanden.."
     # gpspipe ist in Paket gpsd-clients
     os.system('sudo apt-get install gpsd gpsd-clients -y')
     print "[GPS] ",GPSPIPE , "wurde nachinstalliert... Bitte Programm neu starten..."
# ---------------------------------------------------------------------
if __name__ == '__main__':
  main()
# ------------------------------------- EOF ---------------------------
