# -*- coding: utf-8 -*-
#!/usr/bin/python
# ------------------------------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ------------------------------------------------------------------------
# pi_readmqtt.py
# ------------------------------------------------------------------------
import paho.mqtt.client as mqtt
# ----------------------------------------------------
# mqtt-Konfig
localserver = "192.168.123.45"
topic = "iot/#"
# ------------------------------------------------------------------------
def on_connect(client, userdata, rc):
   print("Connected with "+localserver +"\n\nresult code : "+str(rc))
   print("subscribe : " +topic)
   client.subscribe(topic)
# ----------------------------------------------------
def on_message(client, userdata, msg):
   print "Topic: ", msg.topic+'\nMessage: '+str(msg.payload)
# ----------------------------------------------------
def start_mqtt():
   client = mqtt.Client()
   client.on_connect = on_connect
   client.on_message = on_message
   client.connect(localserver, 1883, 60)
   client.loop_forever()
# ----------------------------------------------------
start_mqtt()
# ------------------------ EOF ----------------------------
