#!/usr/bin/python 
# -*- coding: utf-8 -*- 
# ----------------------------------------------------
# E.F.Engelhardt, Franzis Verlag, 2016
# ----------------------------------------------------
# Datei: pygame-step2.py#
# Schritt 2: Ausgabe des Bildschirmhintergrunds und Texts
#
import pygame, sys, os, time
from pygame.locals import *
# Init PyGame
pygame.init()
screen = pygame.display.set_mode((320, 240), 0, 32)
pygame.display.set_caption('PyGame: Schritt 2')
# Farben definieren nach RGB-Schema
BLACK=(0,0,0)
WHITE=(255,255,255)
RED=(255,0,0)
BLUE=(0,0,255)
CYAN=(0,255,255)
MAGENTA=(255,0,255)
YELLOW =(255,255,0)
AQUA=(0,255,255)
FUCHSIA=(255,0,255)
GRAY=(128,128,128)
GREEN=(0,128,0)
LIME=(0,255,0)
MAROON=(128,0,0)
NAVYBLUE=(0,0,128)
OLIVE=(128,128,0)
PURPLE=(128,0,128)
SILVER=(192,192,192)
TEAL=(0,128,128)
# Hintergrund aufbauen
background = pygame.Surface(screen.get_size())
background = background.convert()
background.fill(WHITE)
box = pygame.draw.rect(background,YELLOW,(40,0,40,240))
box = pygame.draw.rect(background,CYAN,(80,0,40,240))
box = pygame.draw.rect(background,LIME,(120,0,40,240))
box = pygame.draw.rect(background,MAGENTA,(160,0,40,240))
box = pygame.draw.rect(background,RED,(200,0,40,240))
box = pygame.draw.rect(background,NAVYBLUE,(240,0,40,240))
box = pygame.draw.rect(background,BLACK,(280,0,40,240))
# Textanzeige
font=pygame.font.Font(None,36)
textstring="HIER STEHT DER TEXT"
text=font.render(textstring,1,(BLACK))
# screen = pygame.transform.rotate(screen,270)
# Textanzeigen und drehen
# text = pygame.transform.rotate(text,270) 
# Position zentral in der Mitte berechnen
textpos = text.get_rect(centerx=background.get_width()/2,centery=background.get_height()/2)
background.blit(text, textpos)
screen.blit(background, (0, 0))
pygame.display.flip()
running = True
os.system('clear')
# Schleife
while running:
   for event in pygame.event.get():
      if event.type == QUIT:
         pygame.quit()
         sys.exit()
         running = False
      elif event.type == pygame.MOUSEBUTTONDOWN:
         print("Position: %sx%s\n" % pygame.mouse.get_pos())
         if textpos.collidepoint(pygame.mouse.get_pos()):
            pygame.quit()
            sys.exit()
            running = False
      elif event.type == KEYDOWN and event.key == K_ESCAPE:
         running = False
   pygame.display.update()
# -------------------- EOF -----------------------

