#!/usr/bin/env python
# -*- coding: utf-8 -*-
# E.F.Engelhardt, Franzis Verlag, 2016/2017
#
# Pfad \sim900
# Datei: sim900-atcommand.py
#----------------------------------------------------------------------
import serial
import time
import sys
#----------------------------------------------------------------------
def close():
   ser.close()  
   sys.exit() 
#----------------------------------------------------------------------
def atcommand(msg, timeout=2, ok='OK', end=13, length=100):
  print "| [SIM900] Kommando : "+msg
  t0 = time.time()
  while True:
    ser.write(msg+chr(end))
    ret = ser.read(length)
    if ok in ret:
      return ret
    if time.time()-t0 >= timeout:
      print "| [SIM900] Fehler beim Ausfuehren von: "+msg
      close()
#-----------------------------------------------------------
# Init 
ser = serial.Serial('/dev/ttyAMA0', 115200, rtscts=True, timeout=1)
ser.open()
# sende AT Kommando
print atcommand('AT+CREG?')
#--------------------- EOF ----------------------------------------
